unit __PS_rus_add;
interface
uses
  __PS_rus,
  Classes,
  SysUTILS;


Const
  //SP_Lex_Delimiters = #39+#9+';:|?!,.<'+#32+'>=*\/-+^#@$%&()[]';  //,     ()
  SP_Lex_Delimiters = #39+#9+'";:|?!,.<'+#32+'>=*\/-+^#@$%&()[]'; //,     ()
  SP_Lex_Size_Min = 2; //   ()

//      ()
function StemWords_Porter(AWords: String; YesUpCase:boolean=false): String;

// -   ()   Sx. UnChar -  
function Get_CountWords_In_String(Sx : String; UnChar: String=' '; YesAllTrim_Before: boolean=true) : integer;
//   ()   Sx   NumWord. UnChar -  
function Get_Word_From_String(Sx : String; NumWord : integer; UnChar: String=' '; YesAllTrim_Before: boolean=true) : String;
//  (   )
function String_ParseWords(Sx:string;
                           ListRes:TStrings;
                           UnChars:string;
                           MinCountCharsInWord:integer=3;
                           YesDouble:boolean=true;
                           YesAllTrim:boolean=true):integer;


implementation

function StemWords_Porter(AWords: String; YesUpCase:boolean=false): String;
//      ()
{
 :
   AWords -   
   YesUpCase -  =TRUE,     ()    ,
                  -  
}
Var
  List:TStrings;
  i:integer;
  S:string;
begin
  Result:=trim(AWords);
  if Result<>'' then begin
     Result:='';
     List:=TStringList.Create;
     TRY
        String_ParseWords(
                          AWords,
                          List,
                          SP_Lex_Delimiters,
                          SP_Lex_Size_Min,
                          true
                         );
        StemWordList_Porter(List);
        i:=-1;
        while i<(List.Count-1) do
         begin
          i:=i+1;
          S:=trim(List[i]);
          if S<>'' then begin
             if YesUpCase then begin
                S:=AnsiUpperCase(S);
             end
             else begin
                S:=AnsiLowerCase(S);
             end;
             Result:=Result+S+' ';
          end;
        end;
        Result:=trim(Result);
     FINALLY
       FreeAndNil(List);
     END;
  end;
end;



function String_ParseWords(Sx:string;
                           ListRes:TStrings;
                           UnChars:string;
                           MinCountCharsInWord:integer=3;
                           YesDouble:boolean=true;
                           YesAllTrim:boolean=true):integer;
//  (  ()  ).
//     () ->    
{
:
 Sx -  
 ListRes -  
 UnChars -  -  ( )
 MinCountCharsInWord - . -   
                      (    ,  "")
 YesDouble -  =TRUE,  ""   ,
                -  ListRes    
 YesAllTrim -  =TRUE,          
  : -   ListRes
}
Var
  S:string;
  i,c:integer;
  Yes:byte;
begin
  Result:=-1;
  if Assigned(ListRes) then begin
     ListRes.Clear;
     if length(Sx)>0 then begin
        if length(UnChars)>0 then begin
           if MinCountCharsInWord<=0 then MinCountCharsInWord:=1;
           c:=Get_CountWords_In_String(Sx,UnChars,false);
           if c>0 then begin
              i:=0;
              while i<c do
               begin
                i:=i+1;
                S:=Get_Word_From_String(Sx, i, UnChars, false);
                if YesAllTrim then begin
                   S:=trim(S);
                end;
                if length(S)>=MinCountCharsInWord then begin
                   Yes:=1;
                   if not YesDouble then begin
                      if ListRes.IndexOf(S)>=0 then Yes:=0;
                   end;
                   if Yes>0 then ListRes.Add(S);
                end;
              end;
           end;
        end
        else begin
           S:=Sx;
           if YesAllTrim then begin
              S:=trim(S);
           end;
           if length(S)>=MinCountCharsInWord then begin
              ListRes.Add(S);
           end;
        end;
     end;
     Result:=ListRes.Count;
  end;
end;


function Get_CountWords_In_String(Sx : String; UnChar: String=' '; YesAllTrim_Before: boolean=true) : integer;
// -    Sx. UnChar -  
var
  InWord : byte;
  i : integer;
begin
  Result:=0;
  if YesAllTrim_Before then Sx:=trim(Sx);
  if length(Sx)>0 then begin
     InWord := 0;
     i:=0;
     while i<length(Sx) do
      begin
       i:=i+1;
       if POS(Sx[i],UnChar)<=0 then begin //  -  
          if InWord<=0 then Result:=Result+1; //   
          InWord:=1; //  
       end
       else begin //  - 
          InWord:=0; //  
       end;
     end;
  end;
end;


function Get_Word_From_String(Sx : String; NumWord : integer; UnChar: String=' '; YesAllTrim_Before: boolean=true) : String;
//    Sx   NumWord. UnChar -  
//YesAllTrim_Before -  TRUE,          
Var
  InWord    : byte;
  NumWordCur, i : integer;
begin
  Result:='';
  if YesAllTrim_Before then Sx:=trim(Sx);
  if length(Sx)>0 then begin
     if NumWord>0 then begin
        InWord := 0;
        NumWordCur:=0;
        i:=0;
        while i<length(Sx) do
         begin
          i:=i+1;
          if POS(Sx[i],UnChar)<=0 then begin //  -  
             if InWord<=0 then NumWordCur:=NumWordCur+1; // -   
             InWord:=1; //  
             if NumWordCur=NumWord then begin // -  
                Result:=Result+Sx[i];   //     
             end;
          end
          else begin  //  - 
             InWord:=0; //  
             if NumWordCur=NumWord then begin //  -  
                i:=length(Sx)+1; //,     
             end;
          end;
        end;
     end;
  end;
end;


end.


